/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-03-10 at 19:36:24 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.speech.v1p1beta1.model;

/**
 * Config to enable speaker diarization.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Cloud Speech-to-Text API. For a detailed explanation
 * see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class SpeakerDiarizationConfig extends com.google.api.client.json.GenericJson {

  /**
   * If 'true', enables speaker detection for each recognized word in the top alternative of the
   * recognition result using a speaker_tag provided in the WordInfo.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean enableSpeakerDiarization;

  /**
   * Maximum number of speakers in the conversation. This range gives you more flexibility by
   * allowing the system to automatically determine the correct number of speakers. If not set, the
   * default value is 6.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer maxSpeakerCount;

  /**
   * Minimum number of speakers in the conversation. This range gives you more flexibility by
   * allowing the system to automatically determine the correct number of speakers. If not set, the
   * default value is 2.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer minSpeakerCount;

  /**
   * Output only. Unused.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer speakerTag;

  /**
   * If 'true', enables speaker detection for each recognized word in the top alternative of the
   * recognition result using a speaker_tag provided in the WordInfo.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getEnableSpeakerDiarization() {
    return enableSpeakerDiarization;
  }

  /**
   * If 'true', enables speaker detection for each recognized word in the top alternative of the
   * recognition result using a speaker_tag provided in the WordInfo.
   * @param enableSpeakerDiarization enableSpeakerDiarization or {@code null} for none
   */
  public SpeakerDiarizationConfig setEnableSpeakerDiarization(java.lang.Boolean enableSpeakerDiarization) {
    this.enableSpeakerDiarization = enableSpeakerDiarization;
    return this;
  }

  /**
   * Maximum number of speakers in the conversation. This range gives you more flexibility by
   * allowing the system to automatically determine the correct number of speakers. If not set, the
   * default value is 6.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getMaxSpeakerCount() {
    return maxSpeakerCount;
  }

  /**
   * Maximum number of speakers in the conversation. This range gives you more flexibility by
   * allowing the system to automatically determine the correct number of speakers. If not set, the
   * default value is 6.
   * @param maxSpeakerCount maxSpeakerCount or {@code null} for none
   */
  public SpeakerDiarizationConfig setMaxSpeakerCount(java.lang.Integer maxSpeakerCount) {
    this.maxSpeakerCount = maxSpeakerCount;
    return this;
  }

  /**
   * Minimum number of speakers in the conversation. This range gives you more flexibility by
   * allowing the system to automatically determine the correct number of speakers. If not set, the
   * default value is 2.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getMinSpeakerCount() {
    return minSpeakerCount;
  }

  /**
   * Minimum number of speakers in the conversation. This range gives you more flexibility by
   * allowing the system to automatically determine the correct number of speakers. If not set, the
   * default value is 2.
   * @param minSpeakerCount minSpeakerCount or {@code null} for none
   */
  public SpeakerDiarizationConfig setMinSpeakerCount(java.lang.Integer minSpeakerCount) {
    this.minSpeakerCount = minSpeakerCount;
    return this;
  }

  /**
   * Output only. Unused.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getSpeakerTag() {
    return speakerTag;
  }

  /**
   * Output only. Unused.
   * @param speakerTag speakerTag or {@code null} for none
   */
  public SpeakerDiarizationConfig setSpeakerTag(java.lang.Integer speakerTag) {
    this.speakerTag = speakerTag;
    return this;
  }

  @Override
  public SpeakerDiarizationConfig set(String fieldName, Object value) {
    return (SpeakerDiarizationConfig) super.set(fieldName, value);
  }

  @Override
  public SpeakerDiarizationConfig clone() {
    return (SpeakerDiarizationConfig) super.clone();
  }

}
